#!/bin/bash

# * this file is part of MOPreload
# * Programmed by Antonio Orefice
# * Released under the GNU General Public License (GPL) version 2.

PARENTDIR=${0%/*}

#Maximum filesize to preload
        MAXMB="15"
#Excluded extension list
        EXCLUDE_LIST='\.avi\|\.vob\|\.mpg\|\.mkv\|\.mp3\|\.ogg\|\.flac\|\.bmp\|\.mov'

MAXKB=`expr $MAXMB \* 1024`
echo "Detecting opened files..."

rm /tmp/openlibs2.txt /tmp/_LiNkS_.txt 2>/dev/null

strace -f -F -e trace=open,access $* 2>/tmp/out &

cd $PARENTDIR
mkdir enabled 2>/dev/null
mkdir disabled 2>/dev/null

echo "Press [ENTER] when you've done"
read
killall strace 2>/dev/null >/dev/null

echo "Detection completed, parsing file list..."
cat /tmp/out |grep "/"|grep -vi boot |grep -vi "/proc/"|grep -vi $EXCLUDE_LIST|grep -vi "/sys/"|grep -vi '\\'|grep -vi "/dev/"|grep -vi O_RDWR|grep -vi O_WRONLY|grep -vi "No such"|grep -vi unfinished|grep -vi "\./"|grep -vi "/etc/passwd"|grep -vi "/etc/group"|cut -f 2 -d '"'|grep -vi xauth|grep -vi etc|grep -vi "\.Trash"|grep -vi ".directory"|grep -vi SIGIO|sort|uniq >/tmp/openlibs2.txt

#Remove symbolic links...
echo "Done with parsing, backtracing symbolic links..."
for file in $(cat /tmp/openlibs2.txt); do
	readlink -m $file >>/tmp/_LiNkS_.txt
done
cat /tmp/_LiNkS_.txt|sort|uniq > /tmp/openlibs2.txt



TOTAL=`cat /tmp/openlibs2.txt | wc -l`

rm enabled/$1.openfiles-*MB.txt 2>/dev/null
rm disabled/$1.openfiles.txt 2>/dev/null
TOTSIZE=0
COUNTER=0
for i in $(cat /tmp/openlibs2.txt); do
        	COUNTER=`expr $COUNTER + 1`
                echo -ne "\r$COUNTER on $TOTAL done, will use `expr $TOTSIZE / 1024`MB to preload them"
		SIZE=0`ls -1sd /$i 2>/dev/null| cut -d "/" -f 1|grep [0-9]|cut -d " " -f 1`

		if [ $SIZE -lt $MAXKB ]; then
        	        file "$i"|grep -v directory |cut -f 1 -d ":" >>enabled/$1.openfiles.txt
			TOTSIZE=`expr $TOTSIZE + $SIZE`
		else
			echo
			echo "Excluding $i because it's too large: $SIZE KB > $MAXKB KB based on user prefs."
		fi


done

echo " "
mv enabled/$1.openfiles.txt enabled/$1.openfiles-`expr $TOTSIZE / 1024`MB.txt
echo "$PARENTDIR/enabled/$1.openfiles-`expr $TOTSIZE / 1024`MB.txt compiled."

